Index: lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/scripts/user-extensions.js.sample
===================================================================
--- lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/scripts/user-extensions.js.sample	(nonexistent)
+++ lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/scripts/user-extensions.js.sample	(revision 4307)
@@ -0,0 +1,75 @@
+/*
+ * By default, Selenium looks for a file called "user-extensions.js", and loads and javascript
+ * code found in that file. This file is a sample of what that file could look like.
+ *
+ * user-extensions.js provides a convenient location for adding extensions to Selenium, like
+ * new actions, checks and locator-strategies.
+ * By default, this file does not exist. Users can create this file and place their extension code
+ * in this common location, removing the need to modify the Selenium sources, and hopefully assisting
+ * with the upgrade process.
+ *
+ * You can find contributed extensions at http://wiki.openqa.org/display/SEL/Contributed%20User-Extensions
+ */
+
+// The following examples try to give an indication of how Selenium can be extended with javascript.
+
+// All do* methods on the Selenium prototype are added as actions.
+// Eg add a typeRepeated action to Selenium, which types the text twice into a text box.
+// The typeTwiceAndWait command will be available automatically
+Selenium.prototype.doTypeRepeated = function(locator, text) {
+    // All locator-strategies are automatically handled by "findElement"
+    var element = this.page().findElement(locator);
+
+    // Create the text to type
+    var valueToType = text + text;
+
+    // Replace the element text with the new text
+    this.page().replaceText(element, valueToType);
+};
+
+// All assert* methods on the Selenium prototype are added as checks.
+// Eg add a assertValueRepeated check, that makes sure that the element value
+// consists of the supplied text repeated.
+// The verify version will be available automatically.
+Selenium.prototype.assertValueRepeated = function(locator, text) {
+    // All locator-strategies are automatically handled by "findElement"
+    var element = this.page().findElement(locator);
+
+    // Create the text to verify
+    var expectedValue = text + text;
+
+    // Get the actual element value
+    var actualValue = element.value;
+
+    // Make sure the actual value matches the expected
+    Assert.matches(expectedValue, actualValue);
+};
+
+// All get* methods on the Selenium prototype result in
+// store, assert, assertNot, verify, verifyNot, waitFor, and waitForNot commands.
+// E.g. add a getTextLength method that returns the length of the text
+// of a specified element.
+// Will result in support for storeTextLength, assertTextLength, etc.
+Selenium.prototype.getTextLength = function(locator) {
+	return this.getText(locator).length;
+};
+
+// All locateElementBy* methods are added as locator-strategies.
+// Eg add a "valuerepeated=" locator, that finds the first element with the supplied value, repeated.
+// The "inDocument" is a the document you are searching.
+PageBot.prototype.locateElementByValueRepeated = function(text, inDocument) {
+    // Create the text to search for
+    var expectedValue = text + text;
+
+    // Loop through all elements, looking for ones that have a value === our expected value
+    var allElements = inDocument.getElementsByTagName("*");
+    for (var i = 0; i < allElements.length; i++) {
+        var testElement = allElements[i];
+        if (testElement.value && testElement.value === expectedValue) {
+            return testElement;
+        }
+    }
+    return null;
+};
+
+
Index: lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/scripts/find_matching_child.js
===================================================================
--- lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/scripts/find_matching_child.js	(nonexistent)
+++ lib/spatial/mapbuilder/tests/selenium/selenium-core-0.8.2/scripts/find_matching_child.js	(revision 4307)
@@ -0,0 +1,69 @@
+/*
+ * Copyright 2004 ThoughtWorks, Inc
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ *
+ */
+
+elementFindMatchingChildren = function(element, selector) {
+  var matches = [];
+
+  var childCount = element.childNodes.length;
+  for (var i=0; i<childCount; i++) {
+    var child = element.childNodes[i];
+    if (selector(child)) {
+      matches.push(child);
+    } else {
+      childMatches = elementFindMatchingChildren(child, selector);
+      matches.push(childMatches);
+    }
+  }
+
+  return matches.flatten();
+}
+
+ELEMENT_NODE_TYPE = 1;
+
+elementFindFirstMatchingChild = function(element, selector) {
+
+  var childCount = element.childNodes.length;
+  for (var i=0; i<childCount; i++) {
+    var child = element.childNodes[i];
+    if (child.nodeType == ELEMENT_NODE_TYPE) {
+      if (selector(child)) {
+        return child;
+      }
+      result = elementFindFirstMatchingChild(child, selector);
+      if (result) {
+        return result;
+      }
+    }
+  }
+  return null;
+}
+
+elementFindFirstMatchingParent = function(element, selector) {
+  var current = element.parentNode;
+  while (current != null) {
+    if (selector(current)) {
+      break;
+    }
+    current = current.parentNode;
+  }
+  return current;
+}
+
+elementFindMatchingChildById = function(element, id) {
+  return elementFindFirstMatchingChild(element, function(element){return element.id==id} );
+}
+
Index: lib/spatial/mapbuilder/lib/model/WpsDescribeProcess.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/WpsDescribeProcess.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/WpsDescribeProcess.js	(revision 4307)
@@ -1,13 +1,17 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: WpsDescribeProcess.js 3657 2007-11-29 09:04:26Z gjvoosten $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
  * Stores a Web Processing service (WPS) Capabilities document as defined by the 
- * Open Geospatial Consortium (http://opengis.org).
+ * Open Geospatial Consortium (http://www.opengeospatial.org/).
  *
  * @constructor
+ * @base ModelBase
  * @author Mike Adair
  * @param modelNode   The model's XML object node from the configuration document.
  * @param parent The model object that this widget belongs to.
Index: lib/spatial/mapbuilder/lib/model/FeatureCollection.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/FeatureCollection.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/FeatureCollection.js	(revision 4307)
@@ -1,11 +1,14 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: FeatureCollection.js 3882 2008-02-27 15:41:33Z gjvoosten $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
  * Stores a GML Feature or FeatureCollection as defined by the
- * Open GIS Conortium http://opengis.org.
+ * Open Geospatial Consortium (http://www.opengeospatial.org/).
  *
  * @constructor
  * @base ModelBase
@@ -18,10 +21,15 @@
   // Inherit the ModelBase functions and parameters
   ModelBase.apply(this, new Array(modelNode, parent));
 
+  this.featureTagName = this.getProperty("mb:featureTagName", "topp:CITY_NAME");
+  this.coordsTagName = this.getProperty("mb:coordsTagName", "//gml:coordinates");
+  this.nodeSelectXpath = this.getProperty("mb:nodeSelectXpath");
+  this.coordSelectXpath = this.getProperty("mb:coordSelectXpath", "topp:the_geom/gml:MultiPoint/gml:pointMember/gml:Point/gml:coordinates");
+
   // Namespace to use when doing Xpath queries, usually set in config file.
-  if (!this.namespace){
-    this.namespace = "xmlns:gml='http://www.opengis.net/gml' xmlns:wfs='http://www.opengis.net/wfs'";
-  }
+  //if (!this.namespace){
+  //  this.namespace = "xmlns:gml='http://www.opengis.net/gml' xmlns:wfs='http://www.opengis.net/wfs'";
+  //}
 
   /**
    * convert coordinates in the GML document to the SRS of the map container, 
@@ -29,34 +37,77 @@
    * @param objRef Pointer to this object.
    */
   this.convertCoords = function(objRef) {
+  
     if( objRef.doc && objRef.containerModel && objRef.containerModel.doc ) {
-	  var coordNodes = objRef.doc.selectNodes("//gml:coordinates");
-	  if (coordNodes.length>0 && objRef.containerModel) {
-	    var srsNode = coordNodes[0].selectSingleNode("ancestor-or-self::*/@srsName");
-	    if ( srsNode.nodeValue.toUpperCase() != objRef.containerModel.getSRS().toUpperCase() ) {
-	      var sourceProj = new Proj(srsNode.nodeValue);
-	      objRef.setParam("modelStatus","converting coordinates");
-	      var containerProj = new Proj(objRef.containerModel.getSRS());
-	      for (var i=0; i<coordNodes.length; ++i) {
-	        var coords = coordNodes[i].firstChild.nodeValue;
-	        var coordsArray = coords.split(' ');
-	        var newCoords = '';
-	        for (var j=0; j<coordsArray.length; ++j) {
-	          var xy = coordsArray[j].split(',');
-	          if (xy.length==2) {
-	            var llTemp = sourceProj.Inverse(xy);
-	            xy = containerProj.Forward(llTemp);
-	            newCoords += xy.join(',') + ' ';
-	          }
-	        }
-	        coordNodes[i].firstChild.nodeValue=newCoords;
-	      }
-	    }
+		  var coordNodes = objRef.doc.selectNodes( objRef.coordsTagName );
+		  if (coordNodes.length>0 && objRef.containerModel) {
+		    var srsNode = coordNodes[0].selectSingleNode("ancestor-or-self::*/@srsName");
+		    if( srsNode && (srsNode.nodeValue.toUpperCase() != objRef.containerModel.getSRS().toUpperCase()) ) {
+		      var sourceProj = new OpenLayers.Projection(srsNode.nodeValue);
+		      objRef.setParam("modelStatus",mbGetMessage("convertingCoords"));
+		      var containerProj = new OpenLayers.Projection(objRef.containerModel.getSRS());
+		      for (var i=0; i<coordNodes.length; ++i) {
+		        var coords = getNodeValue(coordNodes[i]);
+		        var coordsArray = coords.split(' ');
+		        var newCoords = '';
+		        for (var j=0; j<coordsArray.length; ++j) {
+		          var xy = coordsArray[j].split(',');
+		          if (xy.length==2) {
+		            var pt=new OpenLayers.Geometry.Point(xy[0],xy[1]);
+                pt.transform(sourceProj,containerProj);
+		            newCoords += pt.x + ',' + pt.y + ' ';
+		          }
+		        }
+		        coordNodes[i].firstChild.nodeValue=newCoords;
+		      }
+		    }
       }
     }
   }
+  
+  /**
+    * Called when the OWSContext gets loaded
+    */
+  this.loadWfsRequests = function(objRef) {
+    //alert( "FeatureCollection loadModel:"+(new XMLSerializer()).serializeToString(objRef.containerModel.doc))
+    // we need to retrieve all the features
+    if( objRef.containerModel.doc != null) {
+      //alert( "FeatureCollection loadModel:"+(new XMLSerializer()).serializeToString(objRef.containerModel.doc))
+      var featureTypes = objRef.containerModel.doc.selectNodes("/wmc:OWSContext/wmc:ResourceList/wmc:FeatureType");
+      if( featureTypes.length > 0 ) {
+        for( var i=0; i<featureTypes.length; i++) {
+          var httpPayload = new Object();        
+        
+          var wfsFeature = featureTypes[i]
+          //alert( "feature:"+ (new XMLSerializer()).serializeToString(wfsFeature) )
+          
+          var server = wfsFeature.selectSingleNode("wmc:Server")
+          //alert( "server:"+ (new XMLSerializer()).serializeToString(server) )
+          var onlineResource = server.selectSingleNode("wmc:OnlineResource")
+          //alert( "onlineResource:"+ (new XMLSerializer()).serializeToString(onlineResource) )
+          httpPayload.method = onlineResource.getAttribute("method")
+          httpPayload.url = onlineResource.getAttribute("xlink:href")
+          //alert( "server:"+ httpPayload.method + " " + httpPayload.url )
+          
+          var query = wfsFeature.selectSingleNode("wfs:GetFeature")
+          //alert( "query2:"+ (new XMLSerializer()).serializeToString( query ))
+          httpPayload.postData = (new XMLSerializer()).serializeToString( query )
+          
+          // This does not work on IE for some reaso
+          // wfsFeature.model = objRef;
+          objRef.wfsFeature = wfsFeature
+          objRef.newRequest(objRef,httpPayload);
+
+          //objRef.containerModel.setParam('addLayer', wfsFeature);
+          //var sld = wfsFeature.selectSingleNode("wmc:StyleList")
+        }
+      }
+    }
+  }
+  
   this.addFirstListener("loadModel",this.convertCoords,this);
-  if( this.containerModel ) this.containerModel.addListener("loadModel",this.convertCoords,this);
+  
+  if( this.containerModel ) this.containerModel.addListener("loadModel",this.loadWfsRequests,this);
 
   /**
    * Change a feature's visibility.
@@ -80,7 +131,7 @@
 
   /**
    * Returns the list of nodes selected by the nodeSelectpath.  These nodes
-   * will be the individual feature memebers from the collection.
+   * will be the individual feature members from the collection.
    * @return list of nodes selected 
    */
   this.getFeatureNodes = function() {
@@ -93,8 +144,8 @@
    * @return a label for this feature
    */
   this.getFeatureName = function(featureNode) {
-    var labelNode = featureNode.selectSingleNode("topp:CITY_NAME");   //TBD: set this dynamically
-    return labelNode?labelNode.firstChild.nodeValue:"No RSS title";
+    var labelNode = featureNode.selectSingleNode(this.featureTagName);   //TBD: set this dynamically
+    return labelNode?getNodeValue(labelNode):mbGetMessage("noRssTitle");
   }
 
   /**
@@ -112,16 +163,26 @@
    * @return the geometric point for the node
    */
   this.getFeaturePoint = function(featureNode) {
-	 var coordSelectXpath = "topp:the_geom/gml:MultiPoint/gml:pointMember/gml:Point/gml:coordinates";//TBD: set this dynamically
-    var coords = featureNode.selectSingleNode(coordSelectXpath);
+    var coords = featureNode.selectSingleNode(this.coordSelectXpath);
     if (coords) {
-      var point = coords.firstChild.nodeValue.split(',');
+      var point = getNodeValue(coords).split(',');
       return point
     } else {
       return new Array(0,0);  //or some other error to return?
     }
   }
-
-
+  
+ /**
+   * Returns a GML geometry for the feature
+   * @param featureNode the feature node to select from
+   * @return the GML for the node
+   */
+  this.getFeatureGeometry = function(featureNode) {
+    var geometryTag = featureNode.selectSingleNode(this.coordsTagName);
+    if( geometryTag != null )
+      return geometryTag.firstChild;
+    else {
+      alert(mbGetMessage("invalidGeom", (new XMLSerializer()).serializeToString(featureNode)));
+    }
+  }
 }
-
